# https://docs.astral.sh/uv/guides/integration/gitlab/
variables:
  PYTHON_VERSION: "3.10"
  BASE_LAYER: bookworm-slim

lint:
  image: ghcr.io/astral-sh/ruff:alpine
  stage: test
  allow_failure: true
  needs: []
  before_script: ["ruff --version"]
  script:
    - ruff check --output-format=gitlab > code-quality-report.json
  artifacts:
    reports:
      codequality: $CI_PROJECT_DIR/code-quality-report.json

.uv: &uv
  image: ghcr.io/astral-sh/uv:python$PYTHON_VERSION-$BASE_LAYER
  before_script: ["uv --version"]
  variables:
    UV_CACHE_DIR: "$CI_PROJECT_DIR/.cache/uv/"
    UV_SYSTEM_PYTHON: "1"
  cache:
    - key: { files: [ uv.lock ] }
      paths:
        - "$CI_PROJECT_DIR/.cache"

test:
  <<: *uv
  stage: test
  allow_failure: true
  needs: []
  script:
    - uv run pytest
  coverage: '/(?i)total.*? (100(?:\.0+)?\%|[1-9]?\d(?:\.\d+)?\%)$/'
  artifacts:
    paths: [htmlcov]
    when: always
    reports:
      junit: junit.xml
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml

release:
  <<: *uv
  stage: deploy
  needs: []
  before_script: ["uv --version"]
  script:
    - uv build
    - uv publish dist/*
  rules:
    - if: '$CI_COMMIT_TAG'
      when: on_success
    - when: never
  variables:
    UV_PUBLISH_URL: "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/pypi"
    UV_PUBLISH_USERNAME: gitlab-ci-token
    UV_PUBLISH_PASSWORD: "$CI_JOB_TOKEN"
